/*
** Der umstlpbare Wrfel nach Paul Schatz
** Copyright (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
*/
/* $Id: wzeichne.c,v 1.8 2004/10/03 09:41:33 fzk Exp $ */

/* Zeichnen des Wuerfelguertels mit Mesa 3-D */

#ifndef OS_WIN32
  #include <config.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#ifndef OS_WIN32
#include <sys/time.h>
#endif
/* #include <sys/types.h> */

#define CHECKOGLERR
#include "wuerfel.h"

void wAdvanceOptions (BOOLEAN reset);

static int    callFill, callLines, callVirt, callAxis, callTimeform, callTouchline;

void
wZeichnewg (void) {
    unsigned int width;
    unsigned int height;

    rotx = roty = rotz = tranx = trany = tranz = 0.;
    drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;

    if (options.position == -1) {
        halt = FALSE;
    }
    else {
        halt = TRUE;
    }

    if (options.seite == 0) {
        width = FENSTER /* DisplayWidth (display, screen) / 2 */ ;
        height = width;
        options.seite = width;
    }
    else {
        width = height = options.seite;
    }

    glutInitWindowSize (options.seite, options.seite);
       /* glutInitWindowPosition (0, 0); */

    winIdMain = glutCreateWindow ("Der umstlpbare Wrfel nach Paul Schatz");

    owgp = wg;

    glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    wErr(glEnable (GL_DEPTH_TEST));
    wErr(glPolygonMode (GL_FRONT_AND_BACK, polygonMode));

    wCreateDisplayLists ();

    glutKeyboardFunc (wKey);
    glutSpecialFunc (wSpecialKey);
    glutDisplayFunc (wDisplay);
    glutReshapeFunc (wReshape);
    glutIdleFunc (wIdle);

    wCreateMenus ();

    winIdSub =  glutCreateSubWindow (winIdMain, 0, 0, options.seite, options.seite / 7);
/*     glutInitWindowSize (options.seite, options.seite / 7); */
/*     winIdSub =  glutCreateWindow ("Parameter"); */
    glutDisplayFunc (wSubDisplay);
    glutReshapeFunc (wSubReshape);

    glutMainLoop ();
}

void
wDisplay (void) {
    struct timeval tv;

    static int gdf = 0;
    gdf++;
    /*   fprintf (stderr, "glutDisplayFunc %d\n", gdf); */

    if (options.impulse || ((gdf % (5*anzpos)) == 0)) {
      options.impulse = FALSE;
      gdf = 0;
      wAdvanceOptions (ADVANCE);
    }

    glutSetWindow (winIdMain);
    wErr(glClearColor (0.7, 0.7, 0.0, 0.0));
    wErr(glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT));

    wErr(glLoadIdentity ());

    wErr(glTranslatef (tranx + dtranx, trany + dtrany, tranz + dtranz - 5.));

    wErr(glRotatef (rotx + drotx, 1.0, 0.0, 0.0));
    wErr(glRotatef (roty + droty, 0.0, 1.0, 0.0));
    wErr(glRotatef (rotz + drotz, 0.0, 0.0, 1.0));

    if (options.mode == 3) {
      /* negatives Vorzeichn haelt Element 1 fest,
      ** positives Vorzeichen das Element 6
      */
        wErr(glRotatef (-GWINKEL(owgp->wgp.w2), 1.0, 0.0, 0.0));
    }
    if (options.mode == 2 || options.mode == 3) {
        wErr(glRotatef (GWINKEL(owgp->wgp.w), 0.0, 1.0, 0.0));
    }

    if (options.mode == 4) {
      wErr(glTranslatef (-(owgp->wgp.e[22-1].x), 0., 0.));
    }

    callFill = callLines = callVirt = callAxis = callTimeform = callTouchline = 0;

    if (options.position != -1) {
      fprintf (stderr, "Position=%d, weiter mit den Tasten 's', Punkt oder Komma\n",
	       options.position);

      listIdLines = listIdLinesStart + options.position;
      listIdFill = listIdFillStart + options.position;
      listIdVirt = listIdVirtStart + options.position;
      listIdAxis = listIdAxisStart + options.position;
      listIdTouch = listIdTouchStart + options.position;
      listIdDiagonals = listIdDiagonalsStart + options.position;
      listIdCenter = listIdCenterStart + options.position;

      while (options.position > 0) {
	  owgp = (owgp->nextwgp?owgp->nextwgp:owgp);
	  options.position--;
      }
      options.position = -1;
    }

    if (polygonMode == GL_FILL) {
      if (options.wuerfel) {
        wErr(glCallList (listIdFill));
      }
    }
    else {
      if (options.wuerfel) {
        wErr(glCallList (listIdLines));
      }
    }

    if (options.virtuell) {
        wErr(glCallList (listIdVirt));
    }

    if (options.ach) {
        wErr(glCallList (listIdAxis));
    }

    if (options.oloid || options.kuboid) {
	if (options.erzeugende) {
	  wErr(glCallList (listIdTime1));
	}
	if (options.endpunkte) {
	  wErr(glCallList (listIdTime2));
	}
    }
    else {
        if (options.indi) {
	    if (options.erzeugende) {
	        wErr(glCallList (listIdTimeIndi1));
	    }
	    if (options.endpunkte) {
	        wErr(glCallList (listIdTimeIndi2));
	    }
	}
    }
    if (options.touchline) {
        wErr(glCallList (listIdTouch));
    }

    if (options.diagonals) {
        wErr(glCallList (listIdDiagonals));
    }

    if (options.center) {
        wErr(glCallList (listIdCenter));
    }

    glutSwapBuffers ();
}

void
wReshape (int w, int  h) {

/*   static int grf = 0; */
/*   fprintf (stderr, "glutReshapeFunc %d\n", ++grf); */

    glutSetWindow (winIdMain);
    wErr(glViewport (0, 0, w, h));
    wErr(glMatrixMode (GL_PROJECTION));
    wErr(glLoadIdentity ());

    if (options.perspektive) {
        /* wErr(glFrustum (-2.5, 2.5, -2.5, 2.5, 1.0, 10.0)); */
        /* vert. angle, aspect ratio, near, far clipp */
        gluPerspective (60, 1., 1., 200.);
    }
    else {
        /* gute Gre fr Modus 1, um animated gif zu erstellen */
        /* wErr(glOrtho (-0.9, 2.5, -1.7, 1.7, -3.0, 7.0)); */
        /* gute Gre fr Modus 2 und 3, um animated gif zu erstellen */
        wErr(glOrtho (-2.5, 2.5, -2.5, 2.5, -10.0, 10.0));
    }

    wErr(glMatrixMode (GL_MODELVIEW));
    wErr(glLoadIdentity ());

    /* Invoke subwindow reshape */
/*     if (options.info) { */
/*       glutSetWindow (winIdSub); */
/*       glutReshapeWindow (w, h / 7); */
/*       glutPositionWindow (0, 0); */
/*     } */
}

void
wIdle (void) {
/*   static int gif = 0; */
    struct timeval tv;

#ifdef OS_WIN32
    /*
    ** Idle-Loop, wie funktioniert das vernnftig unter Windows ohne select?
    */
    int i, j;
    char buf[2];

    memcpy (&tv, &waittime, sizeof (struct timeval));
    if (tv.tv_usec < 0) {
        tv.tv_usec = - tv.tv_usec;
    }
    j = 1;
    for (i = 1; i < tv.tv_usec; i++) {
        buf[i/i] = buf[j/j];
    }
#else
    memcpy (&tv, &waittime, sizeof (struct timeval));
    select (0, NULL, NULL, NULL, &waittime);
    memcpy (&waittime, &tv, sizeof (struct timeval));
#endif

/*   fprintf (stderr, "glutIdleFunc %d\n", ++gif); */

    if (! halt) {
        wNextPos ();
    }
}

void
wNextPos (void) {
    owgp = owgp->nextwgp ? owgp->nextwgp : wg;
    if (owgp == wg) {
      /* Nach einem vollen Durchlauf, weiter bei der ersten Position */
        listIdLines = listIdLinesStart;
        listIdFill = listIdFillStart;
        listIdVirt = listIdVirtStart;
        listIdAxis = listIdAxisStart;
/*         listIdTime1 = listIdTime1Start; */
/*         listIdTime2 = listIdTime2Start; */
        listIdTouch = listIdTouchStart;
        listIdDiagonals = listIdDiagonalsStart;
        listIdCenter = listIdCenterStart;
    }
    else {
        listIdLines++;
        listIdFill++;
        listIdVirt++;
        listIdAxis++;
        listIdTouch++;
        listIdDiagonals++;
        listIdCenter++;
    }
    if (options.tork) {
        torkle ();
    }
    wPostRedisplay ();
}

void
wPrevPos (void) {
    owgp = owgp->prevwgp ? owgp->prevwgp : last;
    if (owgp == last) {
      /* nach einem vollen Ruecklauf weiter bei der letzten Position */
        listIdLines = listIdLinesStart + anzpos - 1;
        listIdFill  = listIdFillStart  + anzpos - 1;
        listIdVirt  = listIdVirtStart  + anzpos - 1;
        listIdAxis  = listIdAxisStart  + anzpos - 1;
        listIdTouch = listIdTouchStart + anzpos - 1;
        listIdDiagonals = listIdDiagonalsStart + anzpos - 1;;
        listIdCenter = listIdCenterStart       + anzpos - 1;
    }
    else {
        listIdLines--;
	listIdFill--;
	listIdVirt--;
	listIdAxis--;
	listIdTouch--;
        listIdDiagonals--;
        listIdCenter--;
    }
    if (options.tork) {
        torkle ();
    }
    wPostRedisplay ();
}

void
wThisPos (void) {
  /* es wird nicht, wie bei Next oder Prev vor oder zurckgesteppt,
  ** ledigliche nach Veraenderung der x/y/z-Drehung erneut gezeichnet
  */
    wPostRedisplay ();
}

void
wSubDisplay (void) {
    char label[128];

/*   static int gsdf = 0; */
/*   fprintf (stderr, "glutSubDisplayFunc %d\n", ++gsdf); */


    /* Clear subwindow */
    wErr(glutSetWindow (winIdSub));
    wErr(glClearColor (0.25, 0.25, 0.25, 0.0));
    wErr(glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT));

    /* Draw border */
/*     wErr(glColor3f (0.0, 1.0, 0.0)); */
/*     wErr(glBegin (GL_LINE_LOOP)); */
/*       wErr(glVertex2f (0., 0.)); */
/*       wErr(glVertex2f (0., 0.99)); */
/*       wErr(glVertex2f (0.999, 0.99)); */
/*       wErr(glVertex2f (0.999, 0.)); */
/*     wErr(glEnd ()); */

    /* Write State Variables */
    wErr(glColor3f (1.0, 1.0, 1.0));
    sprintf (label, "Modus = %s ", modus_txt[options.mode]);
    wErr(glRasterPos2f (0.02F, 0.82F));
    wDrawString (label);

    sprintf (label, "Darstellung = %s ", darstellung_txt[options.lines]);
    wErr(glRasterPos2f (0.02F, 0.62F));
    wDrawString (label);

    sprintf (label, "Schweben = %s ", options.tork ? "ein" : "aus");
    wErr(glRasterPos2f (0.02F, 0.42F));
    wDrawString (label);

    sprintf (label, "Achsen = %s ", options.ach ? "ein" : "aus");
    wErr(glRasterPos2f (0.02F, 0.22F));
    wDrawString (label);

    sprintf (label, "virtuelle Wrfelpunkte = %s ", options.virtuell ? "ein" : "aus");
    wErr(glRasterPos2f (0.02F, 0.04F));
    wDrawString (label);

    /* Write Banner and info */

    sprintf (label, "Winkel = %6.0f ", GWINKEL (owgp->wgp.w) - 0.01);
    wErr(glRasterPos2f (0.4F, 0.82F));
    wDrawString (label);

    sprintf (label, "Verschiebung x/y/z = %6.2f/%6.2f/%6.2f", tranx+dtranx, trany+dtrany, tranz+dtranz);
    wErr(glRasterPos2f (0.4F, 0.62F));
    wDrawString (label);

    sprintf (label, "Rotation x/y/z = %6.2f/%6.2f/%6.2f",
	     (float)((int)rotx%360), (float)((int)roty%360), (float)((int)rotz%360));
    wErr(glRasterPos2f (0.4F, 0.42F));
    wDrawString (label);

    sprintf (label, "(c) 2004 Franz Zahaurek, http://www.fzk.at");
    wErr(glRasterPos2f (0.4F, 0.04F));
    wDrawString (label);

/*     Anzeige der aktuell dargestellten Display-Liste */
/*     sprintf (label, "DisplayLists %c%c%c%c%c%c", */
/* 	     callFill?'f':'_', callLines?'l':'_', callVirt?'v':'_', */
/* 	     callAxis?'a':'_', callTimeform?'t':'_', callTouchline?'b':'_'); */
/*     wErr(glRasterPos2f (0.8F, 0.82F)); */
/*     wDrawString (label); */

/*     wErr(glColor3f (1.0, 0.0, 1.0)); */
/*     sprintf (label, " This is a subwindow "); */
/*     wErr(glRasterPos2f (0.40F, 0.70F)); */
/*     wDrawStringBig (label); */

/*     sprintf (label, " It has its own OpenGL context "); */
/*     wErr(glRasterPos2f (0.33F, 0.35F)); */
/*     wDrawStringBig (label); */

    if (options.info) {
      glutShowWindow();
    }
    else {
      glutHideWindow();
    }
    glutSwapBuffers ();
}

/* Callback function for reshaping the subwindow */
void
wSubReshape (int w, int h)
{
    wErr(glViewport (0, 0, w, h));
    wErr(glMatrixMode (GL_PROJECTION));
    wErr(glLoadIdentity ());
    /* gluOrtho2D (0.0, 1.0, 0.0, 1.0); */
    wErr(glOrtho (0.0, 1.0, 0.0, 1.0, -1., 1.));
}

void
wPostRedisplay (void) {
    glutPostWindowRedisplay (winIdMain);
    glutPostWindowRedisplay (winIdSub);
}

/* Schweben: Verschiebung und Rotation zufllig steuern */
#define DELTA_T 0.01
#define DELTA_R 1.0
#define LIM_UPP_T 0.8
#define LIM_LOW_T -0.8
#ifdef OS_WIN32
#define ZUF               ((float)ranf (0.))
#else
#define ZUF               ((float)random () / (float)RAND_MAX)
#endif

void
torkle (void) {
    static BOOLEAN firsttime = TRUE;
    static float ddtranx, ddtrany, ddtranz, ddrotx, ddroty, ddrotz;
    static BOOLEAN xup = TRUE;
    static BOOLEAN yup = TRUE;
    static BOOLEAN zup = TRUE;

    if (firsttime || !owgp->nextwgp) {
        firsttime = FALSE;
        ddtranx = ZUF * DELTA_T;
        ddtrany = ZUF * DELTA_T;
        ddtranz = ZUF * DELTA_T;
        ddrotx = ZUF * DELTA_R;
        ddroty = ZUF * DELTA_R;
        ddrotz = ZUF * DELTA_R;
    }

    if (dtranx < LIM_LOW_T || LIM_UPP_T < dtranx) { xup = !xup;}
    if (dtrany < LIM_LOW_T || LIM_UPP_T < dtrany) { yup = !yup;}
    if (dtranz < LIM_LOW_T || LIM_UPP_T < dtranz) { zup = !zup;}

    dtranx += ddtranx * (xup ? 1. : -1.);
    dtrany += ddtrany * (yup ? 1. : -1.);
    dtranz += ddtranz * (zup ? 1. : -1.);
    drotx += ddrotx;
    drotx = drotx > 360. ? drotx - 360. : drotx;
    droty += ddroty;
    droty = droty > 360. ? droty - 360. : droty;
    drotz += ddrotz;
    drotz = drotz > 360. ? drotz - 360. : drotz;
}

char *
getErrorText (GLenum err) {
    switch (err) {
    case GL_INVALID_VALUE:
        return ("GL_INVALID_VALUE");
    case GL_INVALID_ENUM:
        return ("GL_INVALID_ENUM");
    case GL_INVALID_OPERATION:
        return ("GL_INVALID_OPERATION");
    case GL_STACK_OVERFLOW:
        return ("GL_STACK_OVERFLOW");
    case GL_STACK_UNDERFLOW:
        return ("GL_STACK_UNDERFLOW");
    case GL_OUT_OF_MEMORY:
        return ("GL_OUT_OF_MEMORY");
    default:
        return ("unknown errornum");
    }
}

void
wTestGlError (char *text) {

    GLenum err;
    char * errText;

    err = wErr(glGetError ());
    if (err) {
        errText = getErrorText (err);
        fprintf (stderr, "%s: Error-Code = %d/%s\n", text, err, errText);
    }
}

void
wDrawString (char *s)
{
  while (*s) {
    /*      glutBitmapCharacter (GLUT_BITMAP_9_BY_15, *s++); */
    glutBitmapCharacter (GLUT_BITMAP_HELVETICA_10, *s++);
  }
}

#ifdef OS_WIN32
/* Die Funktion ranf() entstammt dem Source-Code von gnuplot-3.7 */
/***********************************************************************
     double ranf(double init)
                RANDom number generator as a Function
     Returns a random floating point number from a uniform distribution
     over 0 - 1 (endpoints of this interval are not returned) using a
     large integer generator.
     This is a transcription from Pascal to Fortran of routine
     Uniform_01 from the paper
     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
     with Splitting Facilities." ACM Transactions on Mathematical
     Software, 17:98-111 (1991)

               GeNerate LarGe Integer
     Returns a random integer following a uniform distribution over
     (1, 2147483562) using the generator.
     This is a transcription from Pascal to Fortran of routine
     Random from the paper
     L'Ecuyer, P. and Cote, S. "Implementing a Random Number Package
     with Splitting Facilities." ACM Transactions on Mathematical
     Software, 17:98-111 (1991)
***********************************************************************/
#define Xm1  2147483563L
#define Xm2  2147483399L
#define Xa1  40014L
#define Xa2  40692L

double ranf(init)
double init;
{

    long k, z;
    static int firsttime = 1;
    static long s1, s2;

    /* (Re)-Initialize seeds if necessary */
    if (init < 0.0 || firsttime == 1) {
        firsttime = 0;
        s1 = 1234567890L;
        s2 = 1234567890L;
    }
    /* Generate pseudo random integers */
    k = s1 / 53668L;
    s1 = Xa1 * (s1 - k * 53668L) - k * 12211;
    if (s1 < 0)
        s1 += Xm1;
    k = s2 / 52774L;
    s2 = Xa2 * (s2 - k * 52774L) - k * 3791;
    if (s2 < 0)
        s2 += Xm2;
    z = s1 - s2;
    if (z < 1)
        z += (Xm1 - 1);

    /*
     * 4.656613057E-10 is 1/Xm1.  Xm1 is set at the top of this file and is
     * currently 2147483563. If Xm1 changes, change this also.
     */
    return (double) 4.656613057E-10 *z;
}
#endif


/* virt   ach    m  lines  info   tork   persp  label  kuboid oloid  wuerf  touch  erzeu  endpu  a  beide, diago, mitte, msg */
static AUTOOPTIONS ao[] = {
  {FALSE, FALSE, 1, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Ausgangsposition"},
  {FALSE, FALSE, 2, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Kante fixiert"},
  {FALSE, FALSE, 3, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Element fixiert"},
  {FALSE, TRUE , 1, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Koordinatenachsen dargestellt"},
  {FALSE, TRUE , 1, FALSE, FALSE, TRUE , FALSE, FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Koordinatenachsen dargestellt, Objekt schwebt"},
  {TRUE , TRUE , 1, FALSE, FALSE, TRUE , FALSE, FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Koordinatenachsen und virtuelle Ecken dargestellt, Objekt schwebt"},
  {TRUE , TRUE , 1, FALSE, FALSE, TRUE , FALSE, TRUE , FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Koordinatenachsen und virtuelle Ecken dargestellt, Ecken beschriftet, Objekt schwebt"},
  {FALSE, FALSE, 1, FALSE, FALSE, TRUE , FALSE, FALSE, FALSE, TRUE , TRUE , FALSE, FALSE, TRUE , 2, FALSE, FALSE, FALSE, "Oloid-Kreise als Zeitform des Wrfelgrtels, Objekt schwebt"},
  {FALSE, FALSE, 1, FALSE, FALSE, TRUE , FALSE, FALSE, FALSE, TRUE , TRUE , TRUE , FALSE, TRUE , 2, FALSE, FALSE, FALSE, "Oloid-Kreise als Zeitform des Wrfelgrtels und Berhrungslinie, Objekt schwebt"},
  {FALSE, FALSE, 1, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE , TRUE , TRUE , TRUE , TRUE , 2, FALSE, FALSE, FALSE, "Oloid als Zeitform des Wrfelgrtels, Erzeugende des Oloids dargestellt"},
  {FALSE, FALSE, 1, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , TRUE , 2, FALSE, FALSE, FALSE, "Oloid, eigenstndiges Objekt, Erzeugende des Oloids dargestellt"},
  {FALSE, TRUE , 1, FALSE, FALSE, TRUE , FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , FALSE, TRUE , 0, FALSE, FALSE, FALSE, "Kuboid-Kurven als Zeitform des Wrfelgrtels, Objekt schwebt"},
  {FALSE, TRUE , 2, FALSE, FALSE, TRUE , FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , FALSE, TRUE , 0, FALSE, FALSE, FALSE, "Kuboid-Kurven als Zeitform des Wrfelgrtels, Objekt schwebt"},
  {FALSE, TRUE , 3, FALSE, FALSE, TRUE , FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , FALSE, TRUE , 0, FALSE, FALSE, FALSE, "Kuboid-Kurven als Zeitform des Wrfelgrtels, Objekt schwebt"},
  {FALSE, TRUE , 1, FALSE, FALSE, TRUE , FALSE, FALSE, TRUE , FALSE, FALSE, TRUE , TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Kuboid ohne Wrfelgrtel, mit Berhrungslinie, Objekt schwebt"},
  {FALSE, FALSE, 1, FALSE, FALSE, TRUE , FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , TRUE , 1, FALSE, FALSE, FALSE, "Das Oloid-Htchen, Erzeugende dargestellt, Objekt schwebt"},
  {FALSE, TRUE , 1, FALSE, FALSE, TRUE , FALSE, FALSE, FALSE, TRUE , FALSE, TRUE , TRUE , TRUE , 0, FALSE, FALSE, FALSE, "Oloid-Konoid, Erzeugende dargestellt, Objekt schwebt"},
};

int maxautooptions = sizeof(ao) / sizeof(ao[0]);

/*
** Automatisches Weiterschalten der Optionen erfolgt so lange, bis eine der
** Tasten t, o, k, <POS1> gedrueckt wird
*/
void
wAdvanceOptions (BOOLEAN reset) {
    static int a = 0;

    if (!options.automatic) {
      return;
    }

    a = (++a) % maxautooptions;

    if (reset == RESET) {
      a = 0;
      rotx = roty = rotz = 0;
      rotx = roty = rotz = 0;
      drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
      tranx = trany = tranz = 0.;
    }
    fprintf (stderr, "Automatik#%02d ", a);

    options.virtuell = ao[a].virtuell;
    options.ach = ao[a].ach;

    options.lines = ao[a].lines;

    options.mode = ao[a].mode;
    options.info = ao[a].info;
    options.tork = ao[a].tork;
    options.perspektive = ao[a].perspektive;
    options.labels = ao[a].labels;
    options.kuboid = ao[a].kuboid;
    options.oloid = ao[a].oloid;
    options.wuerfel = ao[a].wuerfel;
    options.touchline = ao[a].touchline;
    options.erzeugende = ao[a].erzeugende;
    options.endpunkte = ao[a].endpunkte;
    options.axistrans = ao[a].axistrans;

    wCreateDisplayLists ();

    fprintf (stderr, "%s\n", ao[a].msg);
}
